struct descriptor_32 page_aligned xen_gdt[8192];
struct vcpu_guest_context page_aligned xen_ctxt;

struct shared_info page_aligned shared_info = {
    .vcpu_info[0] = {
	.evtchn_upcall_mask    = 1,
    },
};

int grant_frames;
struct grant_entry page_aligned grant_table[GRANT_ENTRIES];
struct xenner_info page_aligned vminfo;

uint64_t gdt_mfn[16];

/* trap/fault info */
const struct trapinfo trapinfo[32] = {
    [  0 ] = { .name = "division by zero",              .ec = 0, .lvl = 1 },
    [  1 ] = { .name = "debug interrupt",               .ec = 0, .lvl = 1 },
    [  2 ] = { .name = "NMI",                           .ec = 0, .lvl = 1 },
    [  3 ] = { .name = "breakpoint",                    .ec = 0, .lvl = 1 },
    [  4 ] = { .name = "overflow",                      .ec = 0, .lvl = 1 },
    [  5 ] = { .name = "bound check",                   .ec = 0, .lvl = 1 },
    [  6 ] = { .name = "illegal instruction",           .ec = 0, .lvl = 1 },
    [  7 ] = { .name = "device not present",            .ec = 0, .lvl = 1 },
    [  8 ] = { .name = "double fault",                  .ec = 1, .lvl = 0 },
    [  9 ] = { .name = "coprocessor",                   .ec = 0, .lvl = 1 },
    [ 10 ] = { .name = "invalid TSS",                   .ec = 1, .lvl = 0 },
    [ 11 ] = { .name = "segment not pesent",            .ec = 1, .lvl = 1 },
    [ 12 ] = { .name = "stack fault",                   .ec = 1, .lvl = 1 },
    [ 13 ] = { .name = "general protection fault",      .ec = 1, .lvl = 1 },
    [ 14 ] = { .name = "page fault",                    .ec = 1, .lvl = 1 },
    [ 16 ] = { .name = "floating point exception",      .ec = 0, .lvl = 1 },
    [ 17 ] = { .name = "alignment",                     .ec = 1, .lvl = 1 },
    [ 18 ] = { .name = "machine check",                 .ec = 0, .lvl = 1 },
    [ 19 ] = { .name = "SIMD floating point exception", .ec = 0, .lvl = 1 },
};

const char *cr0_bits[32] = {
    [  0 ] = "PE",
    [  1 ] = "MP",
    [  2 ] = "EM",
    [  3 ] = "TS",
    [  4 ] = "ET",
    [  5 ] = "NE",
    [ 16 ] = "WP",
    [ 18 ] = "AM",
    [ 29 ] = "NW",
    [ 30 ] = "CD",
    [ 31 ] = "PG",
};
const char *cr4_bits[32] = {
    [  0 ] = "VME",
    [  1 ] = "PVI",
    [  2 ] = "TSD",
    [  3 ] = "DE",
    [  4 ] = "PSE",
    [  5 ] = "PAE",
    [  6 ] = "MCE",
    [  7 ] = "PGE",
    [  8 ] = "PCE",
    [  9 ] = "OSFXSR",
    [ 10 ] = "OSXMMEXCPT",
};
