#include "emu.h"

/* --------------------------------------------------------------------- */

/* FIXME: resync kvm headers after clocksource merge, then drop these lines */
#define KVM_CPUID_SIGNATURE     0x40000000
#define KVM_CPUID_FEATURES      0x40000001

void pv_init(int vcpu)
{
    struct kvm_cpuid_entry entry;
    uint32_t sig[3];
    uint32_t features;

    entry.function = KVM_CPUID_SIGNATURE;
    real_cpuid(&entry);
    sig[0] = entry.ebx;
    sig[1] = entry.ecx;
    sig[2] = entry.edx;

    entry.function = KVM_CPUID_FEATURES;
    real_cpuid(&entry);
    features = entry.eax;

    printk(1, "%s: signature: \"%.12s\", features: 0x%08x\n",
	   __FUNCTION__, (char*)sig, features);

#if 0
    if (feature & (1 << KVM_FEATURE_CLOCKSOURCE)) {
	uint64_t clock = EMU_PA(&shared_info.vcpu_info[0].time);
	printk("%s: register vcpu %d pv clock at 0x%" PRIx64 "\n",
	       __FUNCTION__, vcpu, clock);
	if (0 != wrmsrl_safe(MSR_KVM_PARAVIRT_CLOCK, clock))
	    panic("pv clock wrmsr failed");
    }
#endif
}
